#include <iostream>
#include <chrono>
#include "matoperation.hpp"
using namespace std;

#define TIME_START start=std::chrono::steady_clock::now();
#define TIME_END(NAME) end=std::chrono::steady_clock::now(); \
             duration=std::chrono::duration_cast<std::chrono::milliseconds>(end-start).count();\
             cout<<(NAME)<<": result="<<result \
             <<", duration = "<<duration<<"ms"<<endl;



int main(int argc, char ** argv)
{
    size_t nSize = 200000000;
    float * p1 = new float[nSize]();
    float * p2 = new float[nSize]();
    float result = 0.0f;

    p1[2] = 2.3f;
    p2[2] = 3.0f;
    p1[nSize-1] = 2.0f;
    p2[nSize-1] = 1.1f;

    auto start = std::chrono::steady_clock::now();
    auto end = std::chrono::steady_clock::now();
    auto duration = 0L;

    result = dotproduct1(p1, p2, nSize);
    result = dotproduct1(p1, p2, nSize);

    TIME_START
    result = dotproduct1(p1, p2, nSize);
    TIME_END("normal")

    TIME_START
    result = dotproduct2(p1, p2, nSize);
    TIME_END("group8")

    TIME_START
    result = dotproduct3(p1, p2, nSize);
    TIME_END("AVX2")

    TIME_START
    result = dotproduct4(p1, p2, nSize);
    TIME_END("OpenMP+AVX2")

    TIME_START
    result = dotproduct5(p1, p2, nSize);
    TIME_END("OpenBLAS")

    delete []p1;
    delete []p2;

    return 0;
}